import { SchemaContext } from '..';
/**
 * Get the message to display when a command is forbidden with a data proxy flag
 * @param command the cli command (eg. db push)
 * @returns
 */
export declare const forbiddenCmdWithDataProxyFlagMessage: (command: string) => string;
/**
 * Check that the data proxy cannot be used through the given urls and schema contexts
 * @param command the cli command (eg. db push)
 * @param urls list of urls to check
 * @param schemaContexts list of schema contexts to check
 */
export declare function checkUnsupportedDataProxy({ cmd, schemaContext, urls, }: {
    cmd: string;
    schemaContext?: SchemaContext;
    urls?: (string | undefined)[];
}): void;
