import { PrismaConfigInternal } from '@prisma/config';
/**
 * Get the message to display when a command is forbidden with a data proxy flag
 * @param command the cli command (eg. db push)
 * @returns
 */
export declare const forbiddenCmdFlagWithSchemaEngineWasm: ({ cmd, flag }: {
    cmd: string;
    flag: string;
}) => string;
/**
 * Check that the data proxy cannot be used through the given urls and schema contexts
 * @param command the cli command (eg. db push)
 * @param urls list of urls to check
 * @param schemaContexts list of schema contexts to check
 */
export declare function checkUnsupportedSchemaEngineWasm({ cmd, config, args, flags, }: {
    cmd: string;
    config: PrismaConfigInternal<any>;
    args: Record<string, unknown>;
    flags: Array<string>;
}): void;
