import type * as DMMF from '@prisma/dmmf';
import type { DataSource, GeneratorConfig } from '@prisma/generator';
import { type SchemaFileInput } from '../utils/schemaFileInput';
import { QueryEngineErrorInit } from './queryEngineCommons';
export interface ConfigMetaFormat {
    datasources: DataSource[];
    generators: GeneratorConfig[];
    warnings: string[];
}
export type GetDMMFOptions = {
    datamodel: SchemaFileInput;
    previewFeatures?: string[];
};
export declare class GetDmmfError extends Error {
    constructor(params: QueryEngineErrorInit);
}
/**
 * Wasm'd version of `getDMMF`.
 */
export declare function getDMMF(options: GetDMMFOptions): Promise<DMMF.Document>;
