"use strict";
var import_chunk_CYQLJPPO = require("../chunk-CYQLJPPO.js");
var import_chunk_4VNS5WPM = require("../chunk-4VNS5WPM.js");
describe("isPrismaPostgres", () => {
  test("returns false on invalid or non Prisma Postgres protocols", () => {
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)()).toBe(false);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)("")).toBe(false);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)("mysql://database.url/test")).toBe(false);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)("prisma://database.url/test")).toBe(false);
  });
  test("returns true on valid Prisma Postgres protocols", () => {
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)("prisma+postgres://database.url/test")).toBe(true);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)(`${import_chunk_CYQLJPPO.PRISMA_POSTGRES_PROTOCOL}//database.url/test`)).toBe(true);
  });
});
describe("isPrismaPostgresDev", () => {
  test("returns false on invalid or non Prisma Postgres protocols", () => {
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)()).toBe(false);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)("")).toBe(false);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)("mysql://database.url/test")).toBe(false);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgres)("prisma://database.url/test")).toBe(false);
  });
  test("returns false on valid Prisma Postgres protocols with non localhost host", () => {
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgresDev)("prisma+postgres://database.url/test")).toBe(false);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgresDev)(`${import_chunk_CYQLJPPO.PRISMA_POSTGRES_PROTOCOL}//database.url/test`)).toBe(false);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgresDev)("prisma+postgres://127.0.0.2:5432/test")).toBe(false);
  });
  test("returns true on valid Prisma Postgres protocols with localhost host", () => {
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgresDev)("prisma+postgres://localhost:5432/test")).toBe(true);
    expect((0, import_chunk_CYQLJPPO.isPrismaPostgresDev)("prisma+postgres://127.0.0.1:5432/test")).toBe(true);
  });
});
